version: '3'

services:

  #region mongo related
  # ref. https://hub.docker.com/_/mongo  @ via docker stack deploy or docker-compose

  mongo_db:
    image: mongo
    ports:
      - ${MONGO_DB_PORT:-31204}:27017
    environment:
      MONGO_INITDB_ROOT_USERNAME: root
      MONGO_INITDB_ROOT_PASSWORD: root
    volumes:
      - mongo_db_v:/data/db  #TODO why cannot use ./v here insteadof :mongo_db_v ie must use mount volume and cannot use bind mount
    networks:
      - n

  #TODO how to get mongoexpress required login w/ user+pass; currently envvar ME_CONFIG_MONGODB_ADMINxx not working
  mongo_gui:
    restart: unless-stopped

    depends_on:
      - mongo_db

    image: mongo-express
    ports:
      - ${MONGO_GUI_PORT:-31205}:8081

    environment:
      ME_CONFIG_MONGODB_ADMINUSERNAME: admin
      ME_CONFIG_MONGODB_ADMINPASSWORD: admin
      ME_CONFIG_MONGODB_URL: mongodb://root:root@mongo_db:27017/
    networks:
      - n
  #endregion mongo related


  apiapp:
    depends_on:
     - mongo_db
    build:
      context    : ${build_context__apiapp}
      dockerfile : ${build_dockerfile__apiapp}
    ports:
      - ${APP_PORT_apiapp:-31206}:8000
    environment:
      MONGO_DB_HOST : mongo_db
      MONGO_DB_PORT : 27017
    networks:
      - n


  webapp:
    depends_on:
     - apiapp
    build:
      context    : ${build_context__webapp}
      dockerfile : ${build_dockerfile__webapp}
    ports:
      - ${webapp_APP_PORT:-31207}:5000
    environment:
      API_URL: http://127.0.0.1:${APP_PORT_apiapp:-31206}
    networks:
      - n


networks:
  n:

volumes:
  mongo_db_v:
